#pragma once

#include <map>
#include <string>

using namespace std;

//! A function that executes a command.
typedef void (*func_cmd) ();

//! Any Frida command.
class Cmd {
 public:
    func_cmd f;
    string sigle;

    Cmd( const func_cmd &f_in, const string &sigle_in ) :
        f(f_in), sigle(sigle_in) {};
};

//! The command registry, to be instantiated once.
class Commands : public map<string,Cmd> {
 public:
    //! Register one command.
    void add_one( const Cmd &cmd ){
        insert( make_pair( cmd.sigle, cmd ) ); };
    //! Improve STL's find:
    Cmd* value_of( const string &key ) {
        map<string,Cmd>::iterator pos;
        if ( (pos = find(key)) == end() ) return (Cmd*)0;
        return &(pos->second);
    }

};

//! Singleton, to be instantiated in main.
extern Commands theCommands;

namespace Help {
    void register_commands();
    void help();
};
