#pragma once

#include <exception>
#include <string>
#include <iostream>
using namespace std;

class MyException {
 protected:
    string mesg;
    string category;
 public:
    explicit MyException( const string &mesg_in, const string &cat_in="[untyped exception:] " )
        : mesg( mesg_in ), category( cat_in ) {};
    const string what() const { return category+mesg; };
};

class BadInput : public MyException {
 public:
    explicit BadInput( const string &m ) :
        MyException( m, "[bad input:] " ) {};
};

class NotImplemented : public MyException {
 public:
    explicit NotImplemented( const string &m ) :
        MyException( m, "[not yet implemented:] " ) {};
};

class BadData : public MyException {
 public:
    explicit BadData( const string &m ) :
        MyException( m, "[bad data:] " ) {};
};

class ProgramError : public MyException {
 public:
    explicit ProgramError( const string &m ) :
        MyException( m, "[program error:] " ) {};
};
