using namespace std;

#include <iostream>

#include "myexception.h"
#include "asi.h"
#include "readln.h"

#include "workspace.h"
#include "cmd.h"

// In some cases we do not need to include full header files:
namespace NEdif{ void register_commands(); }; // from edif.h
namespace NPlot{ void register_commands();
    void open(); void close(); }; // from dualplot.h
namespace NFileIO{ void register_commands(); }; // from file_io.h
namespace NFunctions{ void register_functions(); }; // from func.h
namespace NRNG{ void init(); }; // from rng.h
void exec_expression( string expr ); // from expr.h

using namespace std;

// Singleton instances of fundamental classes:
Workspace theWorkspace;
Job theJob;
Commands theCommands;

int main()
{

    string prompt, input;
    Cmd *cmd;

    // Register and initialize modules.
    // Ultimately, this may become a plugin mechanism.
    NFunctions::register_functions();
    Help::register_commands();
    NEdif::register_commands();
    NPlot::register_commands();
    NFileIO::register_commands();
    NRNG::init();
    NPlot::open();

    NRead::exemac("\\i ~/rdarc");

    while(1) {
        try{
            prompt = "FRIDA >"; // (FSel.n() ? FSel.str() : "?") + " > ";
            input = wask(prompt.c_str());		
            if ( input == "qui" || input=="quit" ) {
                NPlot::close();
                exit(0);
            } else if( (cmd = theCommands.value_of(input)) ) {
                (cmd->f)();
            } else {
                input += NRead::pop();
                exec_expression( input );
            }
        }
        catch(exception& e) {
            // cout << "DEBUG: catched in main loop\n";
            cerr << e.what() << endl;
        }       
        catch (...) {
            cerr << "!!!!! meta error "
                "(exception not derived from std::exception)\n";
        }
    } // end main loop
}
