#pragma once

#include <exception>
#include <string>
#include <iostream>
using namespace std;

class MyException : public exception {
 protected:
    string mesg;
 public:
    explicit MyException( const string &m ) throw() { mesg = m; };
    ~MyException() throw() {};
    const char* what() const throw() { return mesg.c_str(); };
};

class BadInput : public MyException {
 public:
    explicit BadInput( const string &m ) throw() :
        MyException( m ) {};
    const char* what() const throw() { 
        return ("! " +mesg).c_str(); };
};

class NotImplemented : public MyException {
 public:
    explicit NotImplemented( const string &m ) throw() :
        MyException( m ) {};
    const char* what() const throw() { 
        return ("Sorry, this function is not yet implemented: " +
                mesg).c_str(); };
};

class BadData : public MyException {
 public:
    explicit BadData( const string &m ) throw() :
        MyException( m ) {};
    const char* what() const throw() { 
        return ("!! " +mesg).c_str(); };
};

class ProgramError : public MyException {
 public:
    explicit ProgramError( const string &m ) throw() :
        MyException( m ) {};
    const char* what() const throw() { 
        return ("!!! FRIDA ERROR: please notify a developer at "
                "frida.sourceforge.net\n" +mesg).c_str(); };
};
