#pragma once

#include <stdio.h>
#include <string>
#include <fstream>
#include <vector>

#include "mydef.h"
#define HAS_TIME

#define SQR(a) ((a)*(a))

using namespace std;

string strg(const string& val);
string strg(const bool& val);
string strg(const int& val);
string strg(const uint& val);
string strg(const char& val);
string strg(const double& val);

namespace mystd {
	
    double justnow(void);
    string myasctime(double time, int offs);
	
    void ssleep(double sec);

    void bell(void);

    double dnint(double val);
    int nint(double val);
	
    extern const double pi;

    double round(double val, double digits);

    int str2vec(string inp, vector<double> *V, uint nmax=0,
                bool force=true);
    void merge(vector<double> *V, double val);
    int get_const(vector<double> *V, double* val=0);
    void unique(vector<double> *V, 
                double tolabs=1e-100, double tolrel=1e-10);

    double any2dbl( string inp );
    int any2int( string inp );

    void string_extract_word( const string in, string *out1, string *out2 );
    void string_extract_line( const string in, string *out1, string *out2 );

    void fname_divide( const string fname, string *fdir, string *fshort, string *fext);

    int glob_file_list(const string text, 
                       const string pre, const string ext, 
                       vector<string> *flong, vector<string> *fshort=0 );
    int glob_one_file(const string text,
                      const string pre, const string ext, string *fname);
    FILE* glob_fopen(const string text, const string pre, const string ext, 
                     const char* mod, string *fname=0);

    int freadln(ifstream *f, string *s);
    int freadln(FILE *fd, string *s);
}
